' Loop Recorder Repeated Autosave 1.2
' for
'
' Loop Recorder
' http://www.looprecorder.de
'
' Repeatedly records and autosaves to date/time named files every 30 minutes.
' The first reording is shortened to the duration to the next full or half hour.
'
' This script is for advanced users only and is not supported.
' It requires the Windows Scripting Host
' http://msdn.microsoft.com/library/default.asp?url=/downloads/list/webdev.asp
'
' NO WARRANTY
'
' BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO
' WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
' APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE
' COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM
' "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR
' IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
' WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
' PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF
' THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE,
' YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
' CORRECTION.
'
' IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
' WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
' MODIFY THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR
' DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
' CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE
' THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA
' BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
' PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
' PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF
' THE POSSIBILITY OF SUCH DAMAGES.
'
'  2003 Thomas Riechmann, Gerald Riechmann
' http://www.looprecorder.de
' info@looprecorder.de
'
' ============================================================================
' CONFIGURATION

' Interval: 1, 2, 3, 5, 10, 15, 20, 30 or 60:
Const saveEveryMins = 30
Const saveTimesMax = 16 ' Set to 0 for infinite

Const additionalOptions = "-i -q:s:44100"

Const filesPrefix = "Rec "
Const baseFolder = "c:\LoopRec Auto\"

' ASF files:
Const fileNameExt = ".asf"
Const bitRate = "96:"		' Format:"<kBit/s>:", e. g. "96:"

' Uncomment for Wave files:
' Const fileNameExt = ".wav"
' Const bitRate = ""

' ============================================================================

set WSHShell = CreateObject("WScript.Shell")
Set fso = CreateObject("Scripting.FileSystemObject")

Dim i, n
Dim fileName, fileFolder, fileDate, fileTime

Set nonFileChars = New RegExp
nonFileChars.Pattern = "[\:\/\\]+"
nonFileChars.Global = True

Const waitForFileSecs = 10

WScript.sleep 1 ' testing the sleep function

n = 1

If not fso.FolderExists(baseFolder) Then
	fso.CreateFolder baseFolder
end if

while true
	fileDate = nonFileChars.replace(FormatDateTime(Now, vbShortDate), "-")
	fileTime = nonFileChars.replace(FormatDateTime(Now, vbLongTime), "-")

	fileFolder = fso.buildPath(baseFolder, fileDate)
	fileName = fso.buildPath(fileFolder, filesPrefix & fileDate & " " & fileTime & fileNameExt)

	If not fso.FolderExists(fileFolder) Then
		fso.CreateFolder fileFolder
		WSHShell.Run "explorer.exe """ & fileFolder & """", , vbFalse
	end if

	secondsLeft = (1000*60*60 - (Minute(Now)*60 + Second(Now))) mod (60*saveEveryMins)
	if secondsLeft < 5 then
		secondsLeft = secondsLeft + 60*saveEveryMins
	end if

	WSHShell.Run "LoopRec.exe " & additionalOptions & " -c:0:" & (secondsLeft - 1) & " -f:" & bitRate & """" & fileName & """", , vbFalse
	WScript.sleep secondsLeft * 1000

	for i = 1 to waitForFileSecs * 2
		if fso.FileExists(fileName) Then
			exit for
		end if
		WScript.sleep 500
	next

	If not fso.FileExists(fileName) Then
		' if WSHShell.Popup("Continue repeated Loop Recording?", 10, "Loop Recorder Script", vbYesNo + vbSystemModal + vbQuestion + vbDefaultButton2) = vbNo then
			WScript.Quit
		' end if
	End If

	If n = saveTimesMax Then
		WScript.Quit
	End If
	n = n + 1
Wend